import{s as ye,o as Te,n as we}from"../chunks/scheduler.0f20f9e5.js";import{S as ve,i as _e,g as r,s as a,r as B,A as Le,h as l,f as i,c as s,j as ge,u as J,x as p,k as $e,y as Me,a as n,v as R,d as k,t as q,w as E}from"../chunks/index.fbd8b8e3.js";import{T as He}from"../chunks/Tip.1ed3d6e3.js";import{C as Ce}from"../chunks/CodeBlock.c14486c2.js";import{H as X}from"../chunks/Heading.2451f3bb.js";function Pe(Z){let o,h="<strong>Beware: bf16 is the optimal compute data type!</strong>",d,m,u="If your hardware supports it, <code>bf16</code> is the optimal compute dtype. The default is <code>float32</code> for backward compatibility and numerical stability. <code>float16</code> often leads to numerical instabilities, but <code>bfloat16</code> provides the benefits of both worlds: numerical stability equivalent to float32, but combined with the memory footprint and significant computation speedup of a 16-bit data type. Therefore, be sure to check if your hardware supports <code>bf16</code> and configure it using the <code>bnb_4bit_compute_dtype</code> parameter in BitsAndBytesConfig:";return{c(){o=r("p"),o.innerHTML=h,d=a(),m=r("p"),m.innerHTML=u},l(f){o=l(f,"P",{"data-svelte-h":!0}),p(o)!=="svelte-ugrp4n"&&(o.innerHTML=h),d=s(f),m=l(f,"P",{"data-svelte-h":!0}),p(m)!=="svelte-nj78a"&&(m.innerHTML=u)},m(f,c){n(f,o,c),n(f,d,c),n(f,m,c)},p:we,d(f){f&&(i(o),i(d),i(m))}}}function xe(Z){let o,h,d,m,u,f,c,se="With Transformers it’s very easy to load any model in 4 or 8-bit, quantizing them on the fly with bitsandbytes primitives.",I,g,oe='Please review the <a href="https://huggingface.co/docs/transformers/v4.37.2/en/quantization#bitsandbytes" rel="nofollow">bitsandbytes section in the Transformers docs</a>.',j,$,re='Details about the BitsAndBytesConfig can be found <a href="https://huggingface.co/docs/transformers/v4.37.2/en/main_classes/quantization#transformers.BitsAndBytesConfig" rel="nofollow">here</a>.',Q,b,U,y,N,T,S,w,le="With <code>PEFT</code>, you can use QLoRA out of the box with <code>LoraConfig</code> and a 4-bit base model.",V,v,fe='Please review the <a href="https://huggingface.co/docs/peft/developer_guides/quantization#quantize-a-model" rel="nofollow">bitsandbytes section in the PEFT docs</a>.',W,_,G,L,pe="Bitsandbytes is also easily usable from within Accelerate.",Y,M,me='Please review the <a href="https://huggingface.co/docs/accelerate/en/usage_guides/quantization" rel="nofollow">bitsandbytes section in the Accelerate docs</a>.',D,H,K,C,ce="You can use any of the 8-bit and/or paged optimizers by simple passing them to the <code>transformers.Trainer</code> class on initialization.All bnb optimizers are supported by passing the correct string in <code>TrainingArguments</code>’s <code>optim</code> attribute - e.g. (<code>paged_adamw_32bit</code>).",O,P,de='See the <a href="https://huggingface.co/docs/transformers/main_classes/trainer#transformers.Trainer" rel="nofollow">official API docs for reference</a>.',ee,x,ue=`Here we point out to relevant doc sections in transformers / peft / Trainer + very briefly explain how these are integrated:
e.g. for transformers state that you can load any model in 8-bit / 4-bit precision, for PEFT, you can use QLoRA out of the box with <code>LoraConfig</code> + 4-bit base model, for Trainer: all bnb optimizers are supported by passing the correct string in <code>TrainingArguments</code>’s <code>optim</code> attribute - e.g. (<code>paged_adamw_32bit</code>):`,te,z,ie,A,be='<li><a href="https://huggingface.co/blog/4bit-transformers-bitsandbytes" rel="nofollow">Making LLMs even more accessible with bitsandbytes, 4-bit quantization and QLoRA</a></li> <li><a href="https://huggingface.co/blog/hf-bitsandbytes-integration" rel="nofollow">A Gentle Introduction to 8-bit Matrix Multiplication for transformers at scale using Hugging Face Transformers, Accelerate and bitsandbytes</a></li>',ne,F,ae;return u=new X({props:{title:"Transformers",local:"transformers",headingTag:"h1"}}),b=new He({props:{warning:!0,$$slots:{default:[Pe]},$$scope:{ctx:Z}}}),y=new Ce({props:{code:"aW1wb3J0JTIwdG9yY2glMEFmcm9tJTIwdHJhbnNmb3JtZXJzJTIwaW1wb3J0JTIwQml0c0FuZEJ5dGVzQ29uZmlnJTBBJTBBcXVhbnRpemF0aW9uX2NvbmZpZyUyMCUzRCUyMEJpdHNBbmRCeXRlc0NvbmZpZyhsb2FkX2luXzRiaXQlM0RUcnVlJTJDJTIwYm5iXzRiaXRfY29tcHV0ZV9kdHlwZSUzRHRvcmNoLmJmbG9hdDE2KQ==",highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> BitsAndBytesConfig

quantization_config = BitsAndBytesConfig(load_in_4bit=<span class="hljs-literal">True</span>, bnb_4bit_compute_dtype=torch.bfloat16)`,wrap:!1}}),T=new X({props:{title:"PEFT",local:"peft",headingTag:"h1"}}),_=new X({props:{title:"Accelerate",local:"accelerate",headingTag:"h1"}}),H=new X({props:{title:"Trainer for the optimizers",local:"trainer-for-the-optimizers",headingTag:"h1"}}),z=new X({props:{title:"Blog posts",local:"blog-posts",headingTag:"h1"}}),{c(){o=r("meta"),h=a(),d=r("p"),m=a(),B(u.$$.fragment),f=a(),c=r("p"),c.textContent=se,I=a(),g=r("p"),g.innerHTML=oe,j=a(),$=r("p"),$.innerHTML=re,Q=a(),B(b.$$.fragment),U=a(),B(y.$$.fragment),N=a(),B(T.$$.fragment),S=a(),w=r("p"),w.innerHTML=le,V=a(),v=r("p"),v.innerHTML=fe,W=a(),B(_.$$.fragment),G=a(),L=r("p"),L.textContent=pe,Y=a(),M=r("p"),M.innerHTML=me,D=a(),B(H.$$.fragment),K=a(),C=r("p"),C.innerHTML=ce,O=a(),P=r("p"),P.innerHTML=de,ee=a(),x=r("p"),x.innerHTML=ue,te=a(),B(z.$$.fragment),ie=a(),A=r("ul"),A.innerHTML=be,ne=a(),F=r("p"),this.h()},l(e){const t=Le("svelte-u9bgzb",document.head);o=l(t,"META",{name:!0,content:!0}),t.forEach(i),h=s(e),d=l(e,"P",{}),ge(d).forEach(i),m=s(e),J(u.$$.fragment,e),f=s(e),c=l(e,"P",{"data-svelte-h":!0}),p(c)!=="svelte-umvy4"&&(c.textContent=se),I=s(e),g=l(e,"P",{"data-svelte-h":!0}),p(g)!=="svelte-1hjynvs"&&(g.innerHTML=oe),j=s(e),$=l(e,"P",{"data-svelte-h":!0}),p($)!=="svelte-1peqy09"&&($.innerHTML=re),Q=s(e),J(b.$$.fragment,e),U=s(e),J(y.$$.fragment,e),N=s(e),J(T.$$.fragment,e),S=s(e),w=l(e,"P",{"data-svelte-h":!0}),p(w)!=="svelte-1pzo32b"&&(w.innerHTML=le),V=s(e),v=l(e,"P",{"data-svelte-h":!0}),p(v)!=="svelte-gc66sr"&&(v.innerHTML=fe),W=s(e),J(_.$$.fragment,e),G=s(e),L=l(e,"P",{"data-svelte-h":!0}),p(L)!=="svelte-yklqdi"&&(L.textContent=pe),Y=s(e),M=l(e,"P",{"data-svelte-h":!0}),p(M)!=="svelte-f0p65c"&&(M.innerHTML=me),D=s(e),J(H.$$.fragment,e),K=s(e),C=l(e,"P",{"data-svelte-h":!0}),p(C)!=="svelte-1lta7zi"&&(C.innerHTML=ce),O=s(e),P=l(e,"P",{"data-svelte-h":!0}),p(P)!=="svelte-l324p4"&&(P.innerHTML=de),ee=s(e),x=l(e,"P",{"data-svelte-h":!0}),p(x)!=="svelte-1auupce"&&(x.innerHTML=ue),te=s(e),J(z.$$.fragment,e),ie=s(e),A=l(e,"UL",{"data-svelte-h":!0}),p(A)!=="svelte-1opwyey"&&(A.innerHTML=be),ne=s(e),F=l(e,"P",{}),ge(F).forEach(i),this.h()},h(){$e(o,"name","hf:doc:metadata"),$e(o,"content",ze)},m(e,t){Me(document.head,o),n(e,h,t),n(e,d,t),n(e,m,t),R(u,e,t),n(e,f,t),n(e,c,t),n(e,I,t),n(e,g,t),n(e,j,t),n(e,$,t),n(e,Q,t),R(b,e,t),n(e,U,t),R(y,e,t),n(e,N,t),R(T,e,t),n(e,S,t),n(e,w,t),n(e,V,t),n(e,v,t),n(e,W,t),R(_,e,t),n(e,G,t),n(e,L,t),n(e,Y,t),n(e,M,t),n(e,D,t),R(H,e,t),n(e,K,t),n(e,C,t),n(e,O,t),n(e,P,t),n(e,ee,t),n(e,x,t),n(e,te,t),R(z,e,t),n(e,ie,t),n(e,A,t),n(e,ne,t),n(e,F,t),ae=!0},p(e,[t]){const he={};t&2&&(he.$$scope={dirty:t,ctx:e}),b.$set(he)},i(e){ae||(k(u.$$.fragment,e),k(b.$$.fragment,e),k(y.$$.fragment,e),k(T.$$.fragment,e),k(_.$$.fragment,e),k(H.$$.fragment,e),k(z.$$.fragment,e),ae=!0)},o(e){q(u.$$.fragment,e),q(b.$$.fragment,e),q(y.$$.fragment,e),q(T.$$.fragment,e),q(_.$$.fragment,e),q(H.$$.fragment,e),q(z.$$.fragment,e),ae=!1},d(e){e&&(i(h),i(d),i(m),i(f),i(c),i(I),i(g),i(j),i($),i(Q),i(U),i(N),i(S),i(w),i(V),i(v),i(W),i(G),i(L),i(Y),i(M),i(D),i(K),i(C),i(O),i(P),i(ee),i(x),i(te),i(ie),i(A),i(ne),i(F)),i(o),E(u,e),E(b,e),E(y,e),E(T,e),E(_,e),E(H,e),E(z,e)}}}const ze='{"title":"Transformers","local":"transformers","sections":[],"depth":1}';function Ae(Z){return Te(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ee extends ve{constructor(o){super(),_e(this,o,Ae,xe,ye,{})}}export{Ee as component};
